#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityMonsterTaskCFG.h"
std::auto_ptr<M_ActivityMonsterTaskCFG> M_ActivityMonsterTaskCFG::msSingleton(nullptr);

int M_ActivityMonsterTaskCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityMonsterTaskCFGData* M_ActivityMonsterTaskCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityMonsterTaskCFGData>& M_ActivityMonsterTaskCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityMonsterTaskCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityMonsterTaskCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityMonsterTaskCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mType = element->IntAttribute("Type");
		data.mDesc = element->Attribute("Desc");
		data.mCompleteType = element->IntAttribute("CompleteType");
		{
			const char* CompleteParam = element->Attribute("CompleteParam");
			std::vector<std::string> vecCompleteParam;
			boost::split(vecCompleteParam, CompleteParam, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCompleteParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCompleteParam[i].c_str(), &temp))
				{
					data.mCompleteParam.push_back(temp);
				}
			}
		}
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		{
			const char* AwardItemID = element->Attribute("AwardItemID");
			std::vector<std::string> vecAwardItemID;
			boost::split(vecAwardItemID, AwardItemID, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemID.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemID[i].c_str(), &temp))
				{
					data.mAwardItemID.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mGoType = element->IntAttribute("GoType");
		{
			const char* FindRand = element->Attribute("FindRand");
			std::vector<std::string> vecFindRand;
			boost::split(vecFindRand, FindRand, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFindRand.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFindRand[i].c_str(), &temp))
				{
					data.mFindRand.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityMonsterTaskCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityMonsterTaskCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityMonsterTaskCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityMonsterTaskCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityMonsterTaskCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		LuaCfgHelper::readInt(L, "CompleteType", data.mCompleteType);
		LuaCfgHelper::readVectorInt(L, "CompleteParam", data.mCompleteParam);
		LuaCfgHelper::readInt(L, "CompleteCount", data.mCompleteCount);
		LuaCfgHelper::readVectorInt(L, "AwardItemID", data.mAwardItemID);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readInt(L, "GoType", data.mGoType);
		LuaCfgHelper::readVectorInt(L, "FindRand", data.mFindRand);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityMonsterTaskCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityMonsterTaskCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityMonsterTaskCFG* M_ActivityMonsterTaskCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityMonsterTaskCFG());
	}
	return msSingleton.get();
}

void M_ActivityMonsterTaskCFG::Release()
{
	msSingleton.reset(nullptr);
}
